<?php
/*
Plugin Name: coComment Enhancer
Plugin URI: http://www.andare.ch/blog/wordpress-plugins/cocomment-enhancer/
Description: Simply inserts the needed javascript to improve interaction with cocomment.com of your Wordpress blog
Author: David Reindl
Version: 1.2.3b
*/

load_plugin_textdomain('coCommentEnhance', 'wp-content/plugins/cocomment_js/');

class coCommentEnhance {

	function option_page_coCommentEnh () {
	
		if(isset($_POST['Options'])) {
			$updCocOptions['toggle'] = $_POST['toggle'];
			$updCocOptions['trackAll'] = $_POST['trackAll'];
			$updCocOptions['toggleImg'] = $_POST['toggleImg'];
			
			update_option('coComment_Enhance', $updCocOptions);
			echo '<div class="updated"><p><strong>' . __('Options updated.', 'coCommentEnhance') . '</strong></p></div>';
		}
		
		$cocOptions = get_settings('coComment_Enhance');

		//Page Presentation
		echo '
			<div class="wrap">
				<h2>' . __('coComment Enhancer Settings', 'coCommentEnhance') . '</h2>
				<form method="post">
					<table width="100%" cellspacing="2" cellpadding="5" class="editform">
						<tr valign="top">
							<th width="33%" scope="row">' . __('No toggle', 'coCommentEnhance') . ':</th>
							<td><input type="radio" name="toggle" id="toggle" ';
		if ($cocOptions['toggle'] == 0) echo ' checked="true"';
		echo ' value="0" />&nbsp;' . __('disabled', 'coCommentEnhance') . '</td>
						</tr>
						<tr valign="top">
							<th width="33%" scope="row">' . __('Use enhanced coComment functions', 'coCommentEnhance') . ':</th>
							<td><input type="radio" name="toggle" id="toggle" ';
		if ($cocOptions['toggle'] == 2) echo ' checked="true"';
		echo ' value="2" />&nbsp;' . __('Enhanced', 'coCommentEnhance') . '<br />
							&nbsp;<input type="checkbox" name="trackAll" id="trackAll" value="1" ';
		if ($cocOptions['trackAll'] == true) echo ' checked="true"';
		echo ' />&nbsp;' . __('by default track all comments (even of non-coComment Users)', 'coCommentEnhance') . '<br />
							&nbsp;' . __('you may enable/disable coComment tracking on a per post basis', 'coCommentEnhance') . '</td>
						</tr>
						<tr valign="top">
							<th width="33%" scope="row">' . __('Display Toggle Switch', 'coCommentEnhance') . ':</th>
							<td><input type="radio" name="toggle" id="toggle" ';
		if ($cocOptions['toggle'] == 1) echo ' checked="true"';
		echo ' value="1" />&nbsp;' . __('Enable', 'coCommentEnhance') . '</td>
						</tr>
						<tr valign="top">
							<th width="33%" scope="row">&nbsp;' . __('Use switch image', 'coCommentEnhance') . ':</th>
							<td>
								&nbsp;<input type="text" name="toggleImg" id="toggleImg" size="80" value="' . $cocOptions['toggleImg'] . '" />
							</td>
						</tr>
						<tr valign="top">
							<th width="33%" scope="row">&nbsp;</th>
							<td>&nbsp;' . __('If you enable the toggle switch and leave this field empty, a textual switch will be display in place of an image.<br />(default is /wp-content/plugins/cocomment_js/cocomment-toggle.gif)', 'coCommentEnhance') . '</td>
						</tr>
					</table>
					<div class="submit"><input type="submit" name="Options" value="' . __('Update Options', 'coCommentEnhance') . ' &raquo;" /></div>
				</form>
			</div>
		';

	}

	function add_options() {
		add_option('coComment_Enhance',array('toggle' => true, 'toggleImg' => '/wp-content/plugins/cocomment_js/cocomment-toggle.gif', 'trackAll' => false),'settings for the coComment Enhance plugin');
		return true;
	}

	function insert_coComment_js ($postid) {
		global $user_ID, $user_identity;
		$cocOptions = get_settings('coComment_Enhance');
		$cocPostOptions = get_post_meta($postid, 'cocomment_trackall', true);
		echo "\n"
		. "<!-- Script snippet to improve interaction with cocomment.com -->\n"
		. "<script type=\"text/javascript\">\n"
		. "var blogTool               = \"WordPress\";\n"
		. "var blogURL                = \"";
		echo get_option('home');
		echo "\";\n"
		. "var blogTitle              = \"";
		bloginfo('name');
		echo "\";\n"
		. "var postURL                = \"";
		the_permalink();
		echo "\";\n"
		. "var postTitle              = \"";
		the_title();
		echo "\";\n";
		if ( $user_ID ) {
			echo "var commentAuthor          = \"";
			echo $user_identity;
			echo "\";\n";
		} else {
			echo "var commentAuthorFieldName = \"author\";\n";
		}
		echo "var commentAuthorLoggedIn  = ";
		if ( !$user_ID ) { echo "false"; }
		else { echo "true"; };
		echo ";\n";
		echo "var commentFormID          = \"commentform\";\n";
		echo "var commentTextFieldName   = \"comment\";\n";
		echo "var commentButtonName      = \"submit\";\n";
		echo "var tags                   = \"";
		foreach ((get_the_category()) as $cat) {
			echo $cat->cat_name . ' ';
			}
		echo "\";\n";
		if ($cocPostOptions != true) echo "var cocomment_force = false;\n";
		echo "\n";
		echo "</script>\n";
		if ($cocOptions['toggle'] == 1 || $cocOptions['toggle'] == 0) { 
			echo "<script type=\"text/javascript\" src=\"http://www.cocomment.com/js/cocomment.js\" ></script>\n";
		} else {
			if ($cocPostOptions == true) echo "<script id=\"cocomment-fetchlet\" trackAllComments=\"true\" src=\"http://www.cocomment.com/js/enabler.js\">\n";
			else echo "<script id=\"cocomment-fetchlet\" src=\"http://www.cocomment.com/js/enabler.js\">\n";
			echo "</script>\n";
		}
		
		if ($cocOptions['toggle'] == 1) {
			echo "<script type=\"text/javascript\">\n"
			. "\tvar coToggleSpan = document.createElement(\"span\");\n"
			. "\tcoToggleSpan.id = \"cocomment-toggle\";\n"
			. "\tvar coToggleA = document.createElement(\"a\");\n"
			. "\tcoToggleA.href = \"#\";\n"
			. "\tvar coToggleImg = document.createElement(\"img\");\n"
			. "\tcoToggleImg.src = \""
			. get_option('siteurl') . $cocOptions['toggleImg'] . "\";\n"
			. "\tcoToggleImg.alt = \"toggle cocomment\";\n"
			. "\tcoToggleImg.width = \"80\";\n"
			. "\tcoToggleImg.border = \"0\";\n"
			. "\tcoToggleImg.height = \"15\";\n"
			. "\tcoToggleImg.onclick = function() {cocomment_toggle();return false};\n"
			. "\tcoToggleA.appendChild(coToggleImg);\n"
			. "\tcoToggleSpan.appendChild(coToggleA);\n"
			. "\tvar coCurrent = document.getElementById('commentform').submit;\n"
			. "\tcoCurrent.parentNode.insertBefore(coToggleSpan, coCurrent.nextSibling);\n"
			. "</script>\n";
		}
	
	}
	
	function insert_coComment_trackall() {
		global $post_ID;
		$cocTmp = get_settings('coComment_Enhance');
		if ($cocTmp['toggle'] == 2) {
			if (isset($post_ID)) {
				$coc_trackall = get_post_meta($post_ID, 'cocomment_trackall', true);
			}
			else {
				$coc_trackall = $cocTmp['trackAll'];
			}
			echo "<fieldset id=\"cocommentdiv\" class=\"dbx-box\">\n"
			    ."\t<h3 class=\"dbx-handle\">coComment option:</h3>\n"
				."\t<div class=\"dbx-content\">\n"
				."\t<input type=\"checkbox\" name=\"cocomment_trackall\" id=\"cocomment_trackall\" value=\"1\"";
			if ($coc_trackall) echo " checked=\"true\"";
			echo " />&nbsp;track all comments\n"
				."\t</div>\n"
				."</fieldset>\n";
		}
	}
	
	function save_post_option($postid) {
//		echo "Post id: $postid / POST: " . $_POST['cocomment_trackall']; exit;
		// Update cocomment trackall setting for current post
		$oldmeta = $newmeta = get_post_meta($postid, 'cocomment_trackall', false);
		$newmeta[0] = $_POST['cocomment_trackall'];


		if (! isset($oldmeta[0]) ) {
			add_post_meta($postid, 'cocomment_trackall', $newmeta[0]);
			return true;
		} elseif ( $newmeta[0] != $oldmeta[0] ) {
			update_post_meta($postid, 'cocomment_trackall', $newmeta[0], $oldmeta[0]);
			return true;
		} else {
			return false;
		}
	}

	function admin_menu($not_used) {
		if (function_exists('add_options_page')) {
			add_options_page('coComment a', 'coComment Enhancer', 5, 'cocomment_js/' . basename(__FILE__), array('coCommentEnhance', 'option_page_coCommentEnh'));
		}

	}

}

if (intval(substr(get_bloginfo('version'), 0, 1)) >= 2 ) {
	register_activation_hook('cocomment_js/' . basename(__FILE__), array('coCommentEnhance', 'add_options'));
}
add_action('admin_menu', array('coCommentEnhance', 'admin_menu'));
add_action('comment_form', array('coCommentEnhance', 'insert_coComment_js'));
add_action('dbx_post_sidebar', array('coCommentEnhance', 'insert_coComment_trackall'));
add_action('save_post', array('coCommentEnhance', 'save_post_option'));
